/* BlinkenLib
 * version 0.5 date 2005-12-06
 * Copyright 2004-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 * a blinkenarea.org project
 */

#ifndef INC_BlinkenFrame
#define INC_BlinkenFrame

typedef struct sBlinkenFrame stBlinkenFrame;

typedef enum eBlinkenProto { BlinkenProtoNone, BlinkenProtoBlp, BlinkenProtoEblp, BlinkenProtoMcuf } etBlinkenProto;

stBlinkenFrame * BlinkenFrameNew( int height, int width, int channels, int maxval, int duration );

stBlinkenFrame * BlinkenFrameClone( stBlinkenFrame * pSrcFrame );

void BlinkenFrameFree( stBlinkenFrame * pFrame );

void BlinkenFrameClear( stBlinkenFrame * pFrame );

int BlinkenFrameGetHeight( stBlinkenFrame * pFrame );
int BlinkenFrameGetWidth( stBlinkenFrame * pFrame );
int BlinkenFrameGetChannels( stBlinkenFrame * pFrame );
int BlinkenFrameGetMaxval( stBlinkenFrame * pFrame );

int BlinkenFrameGetDuration( stBlinkenFrame * pFrame );
void BlinkenFrameSetDuration( stBlinkenFrame * pFrame, int duration );

unsigned char BlinkenFrameGetPixel( stBlinkenFrame * pFrame, int y, int x, int c );
void BlinkenFrameSetPixel( stBlinkenFrame * pFrame, int y, int x, int c, unsigned char val );

unsigned long BlinkenFrameGetColor( stBlinkenFrame * pFrame, int y, int x );
void BlinkenFrameSetColor( stBlinkenFrame * pFrame, int y, int x, unsigned long color );

void BlinkenFrameResize( stBlinkenFrame * pFrame, int height, int width, int channels, int maxval );
void BlinkenFrameScale( stBlinkenFrame * pFrame, int height, int width );

char * BlinkenFrameToString( stBlinkenFrame * pFrame );

int BlinkenFrameToNetwork( stBlinkenFrame * pFrame, etBlinkenProto proto, char * pData, int maxLength );
//returns length or -1 on error

stBlinkenFrame * BlinkenFrameFromNetwork( char * pData, int length, etBlinkenProto * pProto );
//returns protocol in *pProto if pProto not NULL

#endif //#ifndef INC_BlinkenFrame

